﻿## just工具介绍

&emsp;&emsp;Just-spa是一套前端组件工程化工具，可以帮助开发者对物料库进行调用处理，快速进行组件的创建、开发、调试、打包构建，可管理的组件支持React、Vue、Angular或jquer等主流技术栈。从而提高组件管理和开发效率、统一组件规范并分离组件功能、减少人员变动给项目维护带来的额外成本。

#### 1、just管理组件的特点

- 组件高内聚低耦合

- 敏捷高效开发调试

- 支持线上线下数据联调

- 独立开发维护，和业务功能解耦

- 统一管理，减少重复劳动

- 物料自定义，方便组件规范的制定

- 支持React、Vue、Angular、jquery技术栈组件

&emsp;&emsp;这里说的组件可以是任何需要开发调试的组件，为了保证组件规范(目录文档规范和代码规范)的一致性，可以将组件进行一层抽象，生成符合项目规范的物料库，然后通过just init调用物料库快速生成组件，物料库的抽象规范详见[物料库规范](/#template)。

#### 2、just体系功能列表

&emsp;&emsp;**物料与组件**
- 根据物料库快速创建组件：just init，完成后自动安装初始第三方依赖
- 上传自定义物料：物料库可以根据规范进行灵活扩展，上传自己的物料库进行扩展复用：just template
- 删除自定义物料：自定义物料库可以被删除：just rmtemplate
- 组件调试修改实时同步编译，支持调试HMR： just watch
- 快速安装组件的第三方依赖：just install
- 更新组件的第三方依赖：just update
- 快速生成一个项目：just webapp
- 组件打包build：just build componentName
- 主动清除调试服务器缓存：just clear
- 界面化拉取选择第三方依赖
- 组件辅助数据实时mock，调试左侧栏注入数据
- 组件实时文档维护编辑和保存，并且分析组件内文档运行demo代码
- 组件调试页面实时刷新调试
- 支持动态mock数据调试
- 支持单元测试脚本运行
- 支持自定义node脚本运行
- 自动根据组件入口文件代码生成readme.md文档
- 调试中的组件自动添加到alias，其它组件使用包名即可引入使用

&emsp;&emsp;**just系统**
- 查看不同技术栈组件列表
- 支持react、vue、angular、jquery等技术栈物料和组件快速扩展，内置基础物料库
- just系统md文档实时查看
- 应用管理：可以用于管理多项目应用和多版本的创建、调试、发布联调等管理。
- just set可自由设置npm、tnpm、cnpm包管理工具。

#### 3、just体系设计实现

&emsp;&emsp;just体系设计主要分一下几个部分。物料库、组件工作目录、调试服务三部分。

![](/src/docs/img/flow.jpg)

&emsp;&emsp;just命令通过调用物料库快速生成对应的组件，生成的组件可以快速启动调试，调试的组件会同步到开发服务器进行实时编译，通过调试页面访问。