## 文档

#### 1、帮助命令

&emsp;&emsp;了解just所有命令，可以执行`just help`来查看。

```
just init: 创建一个组件或项目。根据组件物料库快速生成一个组件或项目。

just template: 根据自定义组件物料库目录创建一个新的组件物料库。

just rmtemplate: 删除一个自定义组件物料库。

just list: 查看存在的所有组件物料库列表。

just webapp: 调用项目物料库快速生成一个项目工程。

just i/install: 安装组件的第三方依赖，同 npm/tnpm install。

just update: 更新组件的第三方依赖，同 npm/tnpm update。

just start/run -port: 启动调试服务器。一般只需要运行一次。-p或-port表示指定端口开启服务。

just clear/clean: 清除缓存。清除build构建的缓存目录。

just dev/watch: 在当前目录下创建组件调试环境。

just build: 编译打包组件为单个输出的ES5文件并编译CSS文件。例如：just build ComponentName。

just help: 查看帮助。查看just所有命令。

just -v/version: 显示当前安装的just版本。

just set: 设置npm、tnpm或tnpm，例如：just set tnpm。
```

#### 2、快速创建组件或项目

```
just init: 创建一个组件。根据组件物料库快速生成一个组件。
```

&emsp;&emsp;创建组件时我们一般会选择一个本地目录(任何一个空目录)，我们称之为组件工作目录，使用just创建组件时要求输入组件的名称、对应物料库等必填信息和版本号、作者等选填信息。生成过程会调用对应物料库模板，在工作目录下创建组件目录。组件创建完成后如果有第三方包依赖，会自动安装依赖；如果后续添加了新的依赖，则需要手动执行`just install`来安装依赖包，执行时just会分析工作目录下的所有组件的所有第三方依赖包一次性安装，否则调试时会提示找不到包。

```
just webapp: 创建一个项目。根据项目物料库快速选择生成一个项目。
```

&emsp;&emsp;创建项目后，调试页面会有项目应用的入口，进入后可以配置常用的开发、打包、部署命令，并可以通过浏览器在多个项目中进行快速切换和调试。

#### 3、物料库管理

```
just template: 根据自定义组件物料库目录创建一个新的组件物料库。

just rmtemplate: 删除一个自定义组件物料库。

just list: 查看存在的所有组件物料库列表。
```

&emsp;&emsp;通过just上传自定义组件物料库时，需要制指定料库名称、选用技术栈、组件物料库目录路径等信息。

&emsp;&emsp;自定义组件物料库目录需要遵循just组件物料库的制作设计规范，详见[组件物料库规范](/#template)。此外也可以主动删除组件物料库，注意的是这里只能删除自定义的物料库，不能删除系统自带的基础组件物料库。本地可用的组件物料库可以通过`just list`来查看。

#### 4、调试服务

```
just start/run -port: 启动调试服务器。一般只需要运行一次。-p或-port表示指定端口开启服务，如果不指定，则默认为启动8000端口。

just clear/clean: 清除构建的缓存目录。

just dev/watch: 在当前目录下创建组件调试环境。
```

&emsp;&emsp;工作目录下的组件在开启`just watch`时会同步到just的全局调试目录下，`just start`则是在全局调试目录下启动调试服务，该调试方式为组件的单元测试、数据Mock、demo调试等提供了便捷的途径。调试服务器默认集成了React、Vue、angular、Jquery或原生的技术栈的调试支持，而具体的组件物料库开发则可以选用不同的前端技术栈来制作。

&emsp;&emsp;`just clear/clean`可以清除build构建的缓存目录。如果切换了工作目录，调试组件列表中可能含有非该工作目录下的组件，这时为了查看方便，可以通过`just clear`来清除原有调试组件列表，只载入该工作目录下的组件。(这里清除命令并不会清除工作目录下任何内容)

#### 5、依赖管理

&emsp;&emsp;组件的依赖包可以通过 `just i` 一次性安装完成，如果需要安装或管理个别的依赖包，只需要在组件调试界面的组件详情里进行依赖的移除和添加。

#### 6、打包命令

```
just build: 编译打包组件为单个输出的ES5文件并编译CSS文件。例如：just build ComponentName
```

&emsp;&emsp;`just build`仅用于需要将组件转化为es5代码的场景，不推荐使用，目前主要的组件推荐使用ES6的方式对外输出使用。同时，你也可以在组件调试页面中的"打包组件"菜单中自行打包操作。

#### 7、辅助功能

```
just help: 查看帮助。查看just所有命令。

just -v/version: 显示当前安装的just版本。
```

#### 总结

&emsp;&emsp;just工具设计非常简单实用，上手成本极低，但却提供了完整的组件开发管理功能来帮助开发者提高效率。如果使用过程中有什么问题，欢迎issue。